function varargout = Flexure_GUI(varargin)
% FLEXURE_GUI M-file for Flexure_GUI.fig
%      FLEXURE_GUI, by itself, creates alin new FLEXURE_GUI or raises the existing
%      singleton*.
%
%      H = FLEXURE_GUI returns the handle to alin new FLEXURE_GUI or the handle to
%      the existing singleton*.
%
%      FLEXURE_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FLEXURE_GUI.M with the given input arguments.
%
%      FLEXURE_GUI('Property','Value',...) creates alin new FLEXURE_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Flexure_GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Flexure_GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to newGn_flexure (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Flexure_GUI

% Last Modified by GUIDE v2.5 12-Jun-2009 10:47:44

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Flexure_GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @Flexure_GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Flexure_GUI is made visible.
function Flexure_GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Flexure_GUI (see VARARGIN)

% Choose default command line output for Flexure_GUI
handles.output = hObject;

clc

%globalinfo
handles.globalinfo.controlsignals = {'u1','u2','u3','u4','u5','u6'};
handles.globalinfo.platesignals = {'pddx','pddy','pddz','alphax','alphay','alphaz'};
handles.globalinfo.rawplatesignals = {'x1dd','y1dd','x2dd','y2dd','x3dd','y3dd','x4dd','y4dd','x5dd','y5dd','x6dd','y6dd'};
handles.globalinfo.rawforcesignals = {'S1','S2','S3','S4','S5','S6','R1','R2','R3','R4','R5','R6'};
handles.globalinfo.forcesignals = {'Fx','Fy','Fz','Mx','My','Mz'};
handles.globalinfo.speakersignals = {};
handles.globalinfo.maxupdates = 10;
handles.globalinfo.controllerupdates = 0;
handles.globalinfo.errortol = 0;
handles.globalinfo.date = date;
handles.globalinfo.usernotes = [];

%controllerinfo
handles.controllerinfo.Gnfreqs = [];
handles.controllerinfo.Gn = [];
handles.controllerinfo.Gn_raw = [];
handles.controllerinfo.Gn_sp = [];
handles.controllerinfo.maxharmonic = [];
handles.controllerinfo.controlledfreqs = [];
%load controllerinfo.mat which contains the variable controllerinfo, which
%fills in the empty controllerinfo struct fields above
load([pwd,'\SavedGn\controllerinfo'])
handles.controllerinfo = controllerinfo;
handles.controllerinfo.saturation = 4;
handles.controllerinfo.gain = .25;
handles.controllerinfo.input_mag = 1; %have user enter with frequency*************
handles.controllerinfo.V_per_ms2 = 0.01; %NEED TO CALIBRATE

%daqinfo
handles.daqinfo.samples_per_second = 9000;
handles.daqinfo.num_transient_cycles = 35;
handles.daqinfo.num_collected_cycles = 5;
handles.daqinfo.num_processing_cycles = 35;
handles.daqinfo.cycles_per_update = handles.daqinfo.num_transient_cycles+handles.daqinfo.num_collected_cycles+handles.daqinfo.num_processing_cycles;
handles = Initializedaqinfo(handles);

%plateinfo
handles.plateinfo.basefreq = [handles.controllerinfo.controlledfreqs(1)];
handles.plateinfo.Alin = [5 5 5];
handles.plateinfo.Aang = [100 100 100];
handles.plateinfo.T = 1/handles.plateinfo.basefreq;
handles.plateinfo.dt = 1/handles.daqinfo.samples_per_second;
handles.plateinfo.t_all = [0:handles.plateinfo.dt:handles.plateinfo.T-handles.plateinfo.dt]';
handles.plateinfo.constants = {'w = 2*pi*f'};
handles.plateinfo.samples_per_cycle = length(handles.plateinfo.t_all);
handles.plateinfo.d_char = {'A*sin(2*pi*f*t)', 'A*sin(2*pi*f*t)', 'A*sin(2*pi*f*t)', 'A*sin(2*pi*f*t)', 'A*sin(2*pi*f*t)', 'A*sin(2*pi*f*t)'};
handles.plateinfo.filename = 'Temp';

%signalinfo
handles.signalinfo.y = zeros(handles.plateinfo.samples_per_cycle, numel(handles.globalinfo.platesignals));
handles.signalinfo.y_raw = zeros(handles.plateinfo.samples_per_cycle, numel(handles.globalinfo.rawplatesignals));
handles.signalinfo.y_sp = zeros(handles.plateinfo.samples_per_cycle, numel(handles.globalinfo.speakersignals));
handles.signalinfo.u = zeros(handles.plateinfo.samples_per_cycle, numel(handles.globalinfo.controlsignals));
handles.signalinfo.d = zeros(handles.plateinfo.samples_per_cycle, numel(handles.globalinfo.platesignals));
handles.signalinfo.f = zeros(handles.plateinfo.samples_per_cycle, numel(handles.globalinfo.forcesignals));
handles.signalinfo.f_plot = zeros(handles.plateinfo.samples_per_cycle, numel(handles.globalinfo.forcesignals));
handles.signalinfo.A = L2Wconverter(handles);

%forceinfo
handles.forceinfo.crosstalk = [0.0415545, -1.3084753, -0.0209014, 1.3708784, -0.0007212, -0.0037188;
    0.0153681, -0.7556705, 0.0205839, -0.7789058, -0.0193142, 1.5373701;
    -2.3604085, 0.0834155, -2.4158316, 0.0624050, -2.3448311, -0.0132399;
    -1.3171405, -0.1171120, 1.3567893, -0.1945159, -0.0251065,0.3247306;
    -0.7579343,	0.3042172, -0.7516815, -0.2737271, 1.5049942, 0.0110706;
    -0.0274613, 0.7175862, -0.0193200, 0.7383569, -0.0119917, 0.7391482]'; %transposed from Matt's
handles.forceinfo.angle_offset = 70; %offset for force sensor angle in degrees 
handles.forceinfo.maxharmonic = floor(handles.plateinfo.samples_per_cycle/2);
      
%flexureinfo
handles.flexureinfo.Gnfreqs_flexure = [handles.controllerinfo.controlledfreqs(1)];
handles.flexureinfo.Gn_flexure = [];
handles.flexureinfo.f_all = NaN*zeros(numel(handles.globalinfo.forcesignals),handles.plateinfo.samples_per_cycle,numel(handles.flexureinfo.Gnfreqs_flexure),numel(handles.globalinfo.platesignals)); %4-d matrix with all force data.  dim 1 (columns) = Fx through Mz.  dim 2 (rows) = fft of Fx through Mz for logged number of cycles.  dim-3 = frequencies.  dim-4 = pltae inputs

%update plate motion panel in GUI
set(handles.Gnfreqs_flexure,'string',mat2str(handles.flexureinfo.Gnfreqs_flexure))
set(handles.Alin,'string',mat2str(handles.plateinfo.Alin))
set(handles.Aang,'string',mat2str(handles.plateinfo.Aang))

%update sampling panel in GUI
set(handles.samples_per_second,'string',num2str(handles.daqinfo.samples_per_second))
set(handles.samples_per_cycle,'string',num2str(handles.plateinfo.samples_per_cycle))
set(handles.num_transient_cycles,'string',handles.daqinfo.num_transient_cycles)
set(handles.num_collected_cycles,'string',handles.daqinfo.num_collected_cycles)
set(handles.num_processing_cycles,'string',handles.daqinfo.num_processing_cycles)
set(handles.cycles_per_update,'string',num2str(handles.daqinfo.cycles_per_update))
set(handles.time_per_update,'string',num2str(handles.daqinfo.cycles_per_update*handles.plateinfo.T))

%update control signals panel in GUI
set(handles.maxharmonic,'string',num2str(handles.controllerinfo.maxharmonic))
set(handles.controlledfreqs,'string',mat2str(handles.controllerinfo.controlledfreqs))
set(handles.gain,'string',num2str(handles.controllerinfo.gain))
set(handles.saturation,'string',num2str(handles.controllerinfo.saturation))
set(handles.guess,'Value',1)
set(handles.norme,'string','Inf')
set(handles.maxupdates,'string',num2str(handles.globalinfo.maxupdates))
set(handles.controllerupdates,'string',num2str(handles.globalinfo.controllerupdates))
set(handles.errortol,'string',num2str(handles.globalinfo.errortol))

%update control signals plot panel in GUI
InitializeControlPlots(handles);

%update plate signals panel in GUI
InitializePlatePlots(handles);
set(handles.basefreq,'string',[num2str(handles.flexureinfo.Gnfreqs_flexure(1)),' Hz'])

%update force signals panel in GUI
InitializeForcePlots(handles);
set(handles.maxforceharmonic_text,'string',['Highest plotted harmonic (max = ',num2str(floor(handles.plateinfo.samples_per_cycle/2)),'):'])
set(handles.maxforceharmonic,'string',num2str(floor(handles.plateinfo.samples_per_cycle/2)))

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Flexure_GUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Flexure_GUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in newGn_flexure.
function newGn_flexure_Callback(hObject, eventdata, handles)
% hObject    handle to newGn_flexure (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if get(hObject,'value')
    
    %check to make sure that Gnfreqs has all necessary frequencies
    Gnfreqs_flexure = handles.flexureinfo.Gnfreqs_flexure;
    maxharmonic = handles.controllerinfo.maxharmonic;
    Gnfreqs = zeros(1,maxharmonic*numel(Gnfreqs_flexure));
    for i = 1:numel(Gnfreqs_flexure)
        for j = 1:maxharmonic
            Gnfreqs((i-1)*maxharmonic+j) = Gnfreqs_flexure(i)*j;
        end
    end
    Gnfreqs = unique(sort(Gnfreqs));

    %check Gnfreqs above matches what is already stored for Gnfreqs
    if ~isempty(setdiff(Gnfreqs,handles.controllerinfo.Gnfreqs))
        answ = questdlg('New frequency response data for controller must be obtained.  Do you wish to generate it?');
        if strcmp(answ,'Yes')
            handles.controllerinfo.Gnfreqs = Gnfreqs;
            handles = GenerateGn(handles);
            basefreq = handles.plateinfo.basefreq;
            handles.controllerinfo.controlledfreqs = basefreq:basefreq:basefreq*handles.controllerinfo.maxharmonic;
            set(handles.controlledfreqs,'string',[mat2str(handles.controllerinfo.controlledfreqs),'Hz'])
        else
            set(handles.Gnfreqs_flexure,'string',handles.flexureinfo.Gnfreqs_flexure)
            set(hObject,'string','Run','value',0)
            return
        end
    end
    
    %now that Gnfreqs is OK, begin testing
    set(hObject,'string','Stop')
    handles = GenerateGn_flexure(handles);
else
    set(hObject,'string','Run','value',0)
end

guidata(hObject, handles)


function maxupdates_Callback(hObject, eventdata, handles)
% hObject    handle to maxupdates (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of maxupdates as text
%        str2double(get(hObject,'String')) returns contents of maxupdates as alin double

maxupdates = str2double(get(hObject,'String'));

%first test if the value has been changed
if maxupdates ~= handles.globalinfo.maxupdates
    handles.globalinfo.maxupdates = maxupdates;
end

guidata(hObject, handles)

% --- Executes during object creation, after setting all properties.
function maxupdates_CreateFcn(hObject, eventdata, handles)
% hObject    handle to maxupdates (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have alin white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function samples_per_second_Callback(hObject, eventdata, handles)
% hObject    handle to samples_per_second (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of samples_per_second as text
%        str2double(get(hObject,'String')) returns contents of samples_per_second as alin double

samples_per_second = str2double(get(hObject,'String'));

%first test if the value has been changed
if samples_per_second ~= handles.daqinfo.samples_per_second
    
    %update daqinfo
    handles.daqinfo.samples_per_second = samples_per_second;
    handles.daqinfo.ai.SampleRate = samples_per_second;
    handles.daqinfo.ao.SampleRate = samples_per_second;

    %update plateinfo
    T = handles.plateinfo.T;
    dt = 1/samples_per_second;
    handles.plateinfo.t_all = 0:dt:T-dt;
    t_all = handles.plateinfo.t_all;
    t = t_all; %so that you can evaluate desired signals
    handles.plateinfo.samples_per_cycle = length(t_all);

    %update signalinfo
    platesignals = handles.globalinfo.platesignals;
    rawplatesignals = handles.globalinfo.rawplatesignals;
    speakersignals = handles.globalinfo.speakersignals;
    controlsignals = handles.globalinfo.controlsignals;

    handles.signalinfo.y = zeros(length(t_all),numel(platesignals));
    handles.signalinfo.y_raw = zeros(length(t_all), numel(rawplatesignals));
    handles.signalinfo.y_sp = zeros(length(t_all), numel(speakersignals));
    handles.signalinfo.u = zeros(length(t_all), numel(controlsignals));
    handles.signalinfo.d = zeros(length(t_all), numel(platesignals));

    constants = handles.plateinfo.constants;
    f = handles.plateinfo.basefreq;
    for i = 1:length(constants)
        eval([constants{i},';'])
    end
    for i = 1:numel(platesignals)
        handles.signalinfo.d(:,i) = eval(handles.plateinfo.d_char{i}).*ones(size(t_all));
    end

    %update plate motion panel in GUI
    set(handles.platemotionfilename,'string',handles.plateinfo.filename);

    %update sampling panel in GUI
    set(handles.samples_per_second,'string',num2str(handles.daqinfo.samples_per_second))
    set(handles.samples_per_cycle,'string',num2str(handles.plateinfo.samples_per_cycle))

    %update control signals in GUI
    PlotControls(handles)

    %update plate signals in GUI
    PlotPlate(handles)

end

guidata(hObject,handles)

% --- Executes on selection change in constants.
function constants_Callback(hObject, eventdata, handles)
% hObject    handle to constants (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns constants contents as cell array
%        contents{get(hObject,'Value')} returns selected item from constants

constants = get(hObject,'String');

%first test if the value has been changed
if ~strcmp(char(constants),char(handles.plateinfo.constants))

    %update plateinfo
    handles.plateinfo.constants = constants;
    handles.plateinfo.filename = 'temp';

    %update signalinfo
    platesignals = handles.globalinfo.platesignals;
    rawplatesignals = handles.globalinfo.rawplatesignals;
    speakersignals = handles.globalinfo.speakersignals;
    controlsignals = handles.globalinfo.controlsignals;
    
    t = handles.plateinfo.t_all; %call it t so that d_char can be evalulated

    handles.signalinfo.y = zeros(length(t),numel(platesignals));
    handles.signalinfo.y_raw = zeros(length(t), numel(rawplatesignals));
    handles.signalinfo.y_sp = zeros(length(t), numel(speakersignals));
    handles.signalinfo.u = zeros(length(t), numel(controlsignals));
    
    constants = handles.plateinfo.constants;
    f = handles.plateinfo.basefreq;
    for i = 1:length(constants)
        eval([constants{i},';'])
    end
    for i = 1:numel(platesignals)
        handles.signalinfo.d(:,i) = eval(handles.plateinfo.d_char{i}).*ones(size(t));
    end
    
    %make sure d has no NaN entries (e.g., from heaviside functions)
    nanind = find(isnan(handles.signalinfo.d));
    if ~isempty(nanind)
        handles.signalinfo.d(nanind) = handles.signalinfo.d(nanind+1);
    end

    %update plate motion panel in GUI
    set(handles.platemotionfilename,'string',handles.plateinfo.filename);

    %update control signals in GUI
    PlotControls(handles)

    %update plate signals in GUI
    PlotPlate(handles)

end

guidata(hObject, handles)


% --- Executes during object creation, after setting all properties.
function constants_CreateFcn(hObject, eventdata, handles)
% hObject    handle to constants (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have alin white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in savedhandles_listbox.
function savedhandles_listbox_Callback(hObject, eventdata, handles)
% hObject    handle to savedhandles_listbox (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns savedhandles_listbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from savedhandles_listbox

handles = load_signals(handles);

guidata(hObject, handles)


% --- Executes during object creation, after setting all properties.
function savedhandles_listbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to savedhandles_listbox (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have alin white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Gnfreqs_flexure_Callback(hObject, eventdata, handles)
% hObject    handle to Gnfreqs_flexure (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Gnfreqs_flexure as text
%        str2double(get(hObject,'String')) returns contents of
%        Gnfreqs_flexure as alin double

%create vector of all needed frequencies for controlling
%Gnfreqs_flexure with given maxharmonic
Gnfreqs_flexure = eval(get(hObject,'String'));
maxharmonic = handles.controllerinfo.maxharmonic;
Gnfreqs = zeros(1,maxharmonic*numel(Gnfreqs_flexure));
for i = 1:numel(Gnfreqs_flexure)
    for j = 1:maxharmonic
        Gnfreqs((i-1)*maxharmonic+j) = Gnfreqs_flexure(i)*j;
    end
end
Gnfreqs = unique(sort(Gnfreqs));

%check Gnfreqs above matches what is already stored for Gnfreqs
%if ~isequal(Gnfreqs, handles.controllerinfo.Gnfreqs)
if ~isempty(setdiff(Gnfreqs,handles.controllerinfo.Gnfreqs))    
    answ = questdlg('New frequency response data for controller must be obtained to run these frequencies.  Do you wish to generate it?');
    if strcmp(answ,'Yes')
        handles.flexureinfo.Gnfreqs_flexure = Gnfreqs_flexure;
        handles.controllerinfo.Gnfreqs = Gnfreqs;
        handles = GenerateGn(handles);
        basefreq = handles.plateinfo.basefreq;
        handles.controllerinfo.controlledfreqs = basefreq:basefreq:basefreq*handles.controllerinfo.maxharmonic;
        set(handles.controlledfreqs,'string',[mat2str(handles.controllerinfo.controlledfreqs),'Hz'])
    else
        set(handles.Gnfreqs_flexure,'string',mat2str(handles.flexureinfo.Gnfreqs_flexure))
        return
    end
else
    handles.plateinfo.basefreq = Gnfreqs_flexure(1);
    handles.flexureinfo.Gnfreqs_flexure = Gnfreqs_flexure;
    basefreq = handles.plateinfo.basefreq;
    handles.controllerinfo.controlledfreqs = basefreq:basefreq:basefreq*handles.controllerinfo.maxharmonic;
    set(handles.controlledfreqs,'string',[mat2str(handles.controllerinfo.controlledfreqs),'Hz'])
end

basefreq = handles.plateinfo.basefreq;
dt = handles.plateinfo.dt;
T = 1/basefreq;
handles.plateinfo.T = T;
t_all = 0:dt:T-dt;
handles.plateinfo.t_all = t_all;
samples_per_cycle = length(t_all);
handles.plateinfo.samples_per_cycle = samples_per_cycle;


%update sampling panel in GUI
set(handles.samples_per_cycle,'string',num2str(handles.plateinfo.samples_per_cycle))
set(handles.time_per_update,'string',num2str(handles.daqinfo.cycles_per_update*handles.plateinfo.T))

%update plate signals panel in GUI
set(handles.basefreq,'string',[num2str(handles.flexureinfo.Gnfreqs_flexure(1)),' Hz'])

guidata(hObject, handles)


% --- Executes during object creation, after setting all properties.
function Gnfreqs_flexure_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Gnfreqs_flexure (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have alin white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in floatplateaxes.
function floatplateaxes_Callback(hObject, eventdata, handles)
% hObject    handle to floatplateaxes (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

PlotPlate(handles)


function maxharmonic_Callback(hObject, eventdata, handles)
% hObject    handle to maxharmonic (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of maxharmonic as text
%        str2double(get(hObject,'String')) returns contents of maxharmonic as alin double

%create vector of all needed frequencies for controlling
%Gnfreqs_flexure with given maxharmonic
maxharmonic = eval(get(hObject,'String'));
Gnfreqs_flexure = handles.flexureinfo.Gnfreqs_flexure;
Gnfreqs = zeros(1,maxharmonic*numel(Gnfreqs_flexure));
for i = 1:numel(Gnfreqs_flexure)
    for j = 1:maxharmonic
        Gnfreqs((i-1)*maxharmonic+j) = Gnfreqs_flexure(i)*j;
    end
end
Gnfreqs = unique(sort(Gnfreqs));

%check Gnfreqs above matches what is already stored for Gnfreqs
if ~isempty(setdiff(Gnfreqs,handles.controllerinfo.Gnfreqs))   
    answ = questdlg('New frequency response data for controller must be obtained to run with this many harmonics.  Do you wish to generate it?');
    if strcmp(answ,'Yes')
        handles.controllerinfo.maxharmonic = maxharmonic;
        handles.controllerinfo.Gnfreqs = Gnfreqs;
        handles = GenerateGn(handles);
        basefreq = handles.plateinfo.basefreq;
        handles.controllerinfo.controlledfreqs = basefreq:basefreq:basefreq*handles.controllerinfo.maxharmonic;
        set(handles.controlledfreqs,'string',[mat2str(handles.controllerinfo.controlledfreqs),'Hz'])
    else
        set(handles.maxharmonic,'string',handles.controllerinfo.maxharmonic)
        return
    end
else
    handles.controllerinfo.maxharmonic = maxharmonic;
    basefreq = handles.plateinfo.basefreq;
    handles.controllerinfo.controlledfreqs = basefreq:basefreq:basefreq*handles.controllerinfo.maxharmonic;
    set(handles.controlledfreqs,'string',[mat2str(handles.controllerinfo.controlledfreqs),'Hz'])
end

guidata(hObject, handles)

% --- Executes during object creation, after setting all properties.
function maxharmonic_CreateFcn(hObject, eventdata, handles)
% hObject    handle to maxharmonic (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have alin white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in newGn.
function newGn_Callback(hObject, eventdata, handles)
% hObject    handle to newGn (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

plateinfo = handles.plateinfo;
signalinfo = handles.signalinfo;
basefreq = handles.plateinfo.basefreq;
maxharmonic = handles.controllerinfo.maxharmonic;
answer = inputdlg({'Enter frequencies for testing system response:';'Enter input voltage:'},'Input Frequencies',[1],{strcat('[',num2str(basefreq),':',num2str(basefreq),':',num2str(basefreq*maxharmonic),']');'1'});
if ~isempty(answer)
    Gnfreqs = eval(answer{1});
    input_mag = eval(answer{2});
    handles.controllerinfo.Gnfreqs = Gnfreqs;
    handles.controllerinfo.input_mag = input_mag;

    handles = GenerateGn(handles);
    
    %reset plateinfo and signalinfo
    handles.plateinfo = plateinfo;
    handles.signalinfo = signalinfo;
    
    %update plateinfo
    %check to see if Gnfreqs_flexure has to change due to new Gn
    basefreq = handles.plateinfo.basefreq;
    if isempty(find(basefreq == Gnfreqs))
        %determine closest allowable base frequency
        [val ind] = min(abs(basefreq - Gnfreqs));
        warndlg(['Frequency response data does not include ',num2str(basefreq),'Hz.  Base frequency will be set to',num2str(Gnfreqs(ind)),'Hz'])
        uiwait
        basefreq = Gnfreqs(ind);
        handles.plateinfo.basefreq = basefreq;
        handles.plateinfo.T = 1/basefreq;
        T = handles.plateinfo.T;
        dt = handles.plateinfo.dt;
        handles.plateinfo.t_all = 0:dt:T-dt;
        t_all = handles.plateinfo.t_all;
        t = t_all; %so that you can evaluate desired signals
        handles.plateinfo.samples_per_cycle = length(t_all);
        handles.plateinfo.filename = 'temp';

        %update controllerinfo
        Gnfreqs = handles.controllerinfo.Gnfreqs;
        maxharmonic = handles.controllerinfo.maxharmonic;
        if maxharmonic*basefreq > Gnfreqs(end)
            maxharmonic_limit = floor(Gnfreqs(end)/basefreq);
            warndlg(['Cannot control ',num2str(maxharmonic),' harmonics with current frequency response data.  Highest controlled harmonic will be set to ',num2str(maxharmonic_limit),'.'])
            uiwait
            maxharmonic = maxharmonic_limit;
        end
        handles.controllerinfo.maxharmonic = maxharmonic;
        handles.controllerinfo.controlledfreqs = basefreq:basefreq:basefreq*maxharmonic;

        %update signalinfo
        platesignals = handles.globalinfo.platesignals;
        rawplatesignals = handles.globalinfo.rawplatesignals;
        speakersignals = handles.globalinfo.speakersignals;
        controlsignals = handles.globalinfo.controlsignals;

        handles.signalinfo.y = zeros(length(t_all),numel(platesignals));
        handles.signalinfo.y_raw = zeros(length(t_all), numel(rawplatesignals));
        handles.signalinfo.y_sp = zeros(length(t_all), numel(speakersignals));
        handles.signalinfo.u = zeros(length(t_all), numel(controlsignals));
        handles.signalinfo.d = zeros(length(t_all), numel(platesignals));
        
        constants = handles.plateinfo.constants;
        f = handles.plateinfo.basefreq;
        for i = 1:length(constants)
            eval([constants{i},';'])
        end
        for i = 1:numel(platesignals)
            handles.signalinfo.d(:,i) = eval(handles.plateinfo.d_char{i}).*ones(size(t_all));
        end
    end
    
    %update plate motion panel in GUI
    set(handles.Gnfreqs_flexure,'string',num2str(handles.plateinfo.basefreq))
    %set(handles.platemotionfilename,'string',handles.plateinfo.filename);

    %update sampling panel in GUI
    set(handles.samples_per_cycle,'string',num2str(handles.plateinfo.samples_per_cycle))

    %update control signals panel in GUI
    set(handles.controlledfreqs,'string',mat2str(handles.controllerinfo.controlledfreqs))
    set(handles.maxharmonic,'string',num2str(handles.controllerinfo.maxharmonic))

    %update control signals in GUI
    PlotControls(handles)

    %update plate signals in GUI
    PlotPlate(handles)
end

guidata(hObject, handles)
        
% --- Executes on button press in exporthandles.
function exporthandles_Callback(hObject, eventdata, handles)
% hObject    handle to exporthandles (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

assignin('base','handles',handles)

% --- Executes on button press in viewGn.
function viewGn_Callback(hObject, eventdata, handles)
% hObject    handle to viewGn (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

ViewGn_GUI(handles)


function saturation_Callback(hObject, eventdata, handles)
% hObject    handle to saturation (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of saturation as text
%        str2double(get(hObject,'String')) returns contents of saturation as alin double

saturation = str2double(get(hObject,'String'));

%first test if the value has been changed
if saturation ~= handles.controllerinfo.saturation
    handles.controllerinfo.saturation = saturation;
end

PlotControls(handles)

guidata(hObject, handles)

% --- Executes during object creation, after setting all properties.
function saturation_CreateFcn(hObject, eventdata, handles)
% hObject    handle to saturation (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have alin white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function samples_per_second_CreateFcn(hObject, eventdata, handles)
% hObject    handle to samples_per_second (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have alin white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in savehandles.
function savehandles_Callback(hObject, eventdata, handles)
% hObject    handle to savehandles (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[file, path] = uiputfile([cd,'\Savedhandles\',handles.plateinfo.filename,'.mat'],'Save Handles As');
if file ~= 0
    save([pwd,'\Savedhandles\',file],'handles')
end

guidata(hObject, handles)



function num_transient_cycles_Callback(hObject, eventdata, handles)
% hObject    handle to num_transient_cycles (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of num_transient_cycles as text
%        str2double(get(hObject,'String')) returns contents of num_transient_cycles as alin double

num_transient_cycles = str2double(get(hObject,'String'));

%first test if the value has been changed
if num_transient_cycles ~= handles.daqinfo.num_transient_cycles
    handles.daqinfo.num_transient_cycles = num_transient_cycles;
    handles.daqinfo.cycles_per_update = handles.daqinfo.num_transient_cycles+handles.daqinfo.num_collected_cycles+handles.daqinfo.num_processing_cycles;
    set(handles.cycles_per_update,'string',num2str(handles.daqinfo.cycles_per_update))
    set(handles.time_per_update,'string',num2str(handles.daqinfo.cycles_per_update*handles.plateinfo.T))
end

guidata(hObject, handles)

% --- Executes during object creation, after setting all properties.
function num_transient_cycles_CreateFcn(hObject, eventdata, handles)
% hObject    handle to num_transient_cycles (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have alin white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function num_collected_cycles_Callback(hObject, eventdata, handles)
% hObject    handle to num_collected_cycles (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of num_collected_cycles as text
%        str2double(get(hObject,'String')) returns contents of num_collected_cycles as alin double

num_collected_cycles = str2double(get(hObject,'String'));

%first test if the value has been changed
if num_collected_cycles ~= handles.daqinfo.num_collected_cycles
    handles.daqinfo.num_collected_cycles = num_collected_cycles;
    handles.daqinfo.cycles_per_update = handles.daqinfo.num_transient_cycles+handles.daqinfo.num_collected_cycles+handles.daqinfo.num_processing_cycles;
    set(handles.cycles_per_update,'string',num2str(handles.daqinfo.cycles_per_update))
    set(handles.time_per_update,'string',num2str(handles.daqinfo.cycles_per_update*handles.plateinfo.T))
end

guidata(hObject, handles)

% --- Executes during object creation, after setting all properties.
function num_collected_cycles_CreateFcn(hObject, eventdata, handles)
% hObject    handle to num_collected_cycles (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have alin white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function num_processing_cycles_Callback(hObject, eventdata, handles)
% hObject    handle to num_processing_cycles (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of num_processing_cycles as text
%        str2double(get(hObject,'String')) returns contents of num_processing_cycles as alin double

num_processing_cycles = str2double(get(hObject,'String'));

%first test if the value has been changed
if num_processing_cycles ~= handles.daqinfo.num_processing_cycles
    handles.daqinfo.num_processing_cycles = num_processing_cycles;
    handles.daqinfo.cycles_per_update = handles.daqinfo.num_transient_cycles+handles.daqinfo.num_collected_cycles+handles.daqinfo.num_processing_cycles;
    set(handles.cycles_per_update,'string',num2str(handles.daqinfo.cycles_per_update))
    set(handles.time_per_update,'string',num2str(handles.daqinfo.cycles_per_update*handles.plateinfo.T))
end

guidata(hObject, handles)

% --- Executes during object creation, after setting all properties.
function num_processing_cycles_CreateFcn(hObject, eventdata, handles)
% hObject    handle to num_processing_cycles (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have alin white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function gain_Callback(hObject, eventdata, handles)
% hObject    handle to gain (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of gain as text
%        str2double(get(hObject,'String')) returns contents of gain as alin double


gain = str2double(get(hObject,'String'));

%first test if the value has been changed
if gain ~= handles.controllerinfo.gain
    handles.controllerinfo.gain = gain;
end

guidata(hObject, handles)

% --- Executes during object creation, after setting all properties.
function gain_CreateFcn(hObject, eventdata, handles)
% hObject    handle to gain (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have alin white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in signaldetails.
function signaldetails_Callback(hObject, eventdata, handles)
% hObject    handle to signaldetails (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

SignalDetails_GUI(handles)


% --- Executes on button press in floatcontrolaxes.
function floatcontrolaxes_Callback(hObject, eventdata, handles)
% hObject    handle to floatcontrolaxes (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of floatcontrolaxes

PlotControls(handles)


% --- Executes when selected object is changed in initialcontrol.
function initialcontrol_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in initialcontrol 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in testresponse.
function testresponse_Callback(hObject, eventdata, handles)
% hObject    handle to testresponse (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
ResponseToCustomControls_GUI
uiwait
handles = Initializedaqinfo(handles);

guidata(hObject, handles)


% --- Executes on button press in resetdaq.
function resetdaq_Callback(hObject, eventdata, handles)
% hObject    handle to resetdaq (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
clc
if get(handles.newGn_flexure,'value')
    set(handles.newGn_flexure,'string','Run')
    set(handles.newGn_flexure,'value',0)
end
handles = Initializedaqinfo(handles);

%update sampling panel in GUI
set(handles.samples_per_second,'string',num2str(handles.daqinfo.samples_per_second))
set(handles.samples_per_cycle,'string',num2str(handles.plateinfo.samples_per_cycle))
set(handles.num_transient_cycles,'string',handles.daqinfo.num_transient_cycles)
set(handles.num_collected_cycles,'string',handles.daqinfo.num_collected_cycles)
set(handles.num_processing_cycles,'string',handles.daqinfo.num_processing_cycles)
set(handles.cycles_per_update,'string',num2str(handles.daqinfo.cycles_per_update))
set(handles.time_per_update,'string',num2str(handles.daqinfo.cycles_per_update*handles.plateinfo.T))

guidata(hObject, handles)



function errortol_Callback(hObject, eventdata, handles)
% hObject    handle to errortol (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of errortol as text
%        str2double(get(hObject,'String')) returns contents of errortol as alin double

errortol = str2double(get(hObject,'String'));

%first test if the value has been changed
if errortol ~= handles.globalinfo.errortol
    handles.globalinfo.errortol = errortol;
end



% --- Executes during object creation, after setting all properties.
function errortol_CreateFcn(hObject, eventdata, handles)
% hObject    handle to errortol (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have alin white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function Alin_Callback(hObject, eventdata, handles)
% hObject    handle to Alin (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Alin as text
%        str2double(get(hObject,'String')) returns contents of Alin as alin double
Alin_char = get(hObject,'String');

if isempty(Alin_char)
    Alin_char = '1';
    set(hObject,'string',Alin_char)
    set(handles.Alin,'string',mat2str(handles.plateinfo.Alin));
end

if ~strcmp(Alin_char, num2str(handles.plateinfo.Alin))
    handles.plateinfo.Alin = str2num(Alin_char);
end

% %first test if the value has been changed
% if ~strcmp(Alin_char, num2str(handles.plateinfo.Alin))
%     
%     handles.plateinfo.d_char{ind} = d_char_alphaz;
% 
%     %update signalinfo
%     platesignals = handles.globalinfo.platesignals;
%     rawplatesignals = handles.globalinfo.rawplatesignals;
%     speakersignals = handles.globalinfo.speakersignals;
%     controlsignals = handles.globalinfo.controlsignals;
%     
%     t = handles.plateinfo.t_all; %call it t so that d_char can be evalulated
% 
%     handles.signalinfo.y = zeros(length(t),numel(platesignals));
%     handles.signalinfo.y_raw = zeros(length(t), numel(rawplatesignals));
%     handles.signalinfo.y_sp = zeros(length(t), numel(speakersignals));
%     handles.signalinfo.u = zeros(length(t), numel(controlsignals));
%     
%     constants = handles.plateinfo.constants;
%     f = handles.plateinfo.basefreq;
%     for i = 1:length(constants)
%         eval([constants{i},';'])
%     end
%     handles.signalinfo.d(:,ind) = eval(handles.plateinfo.d_char{ind}).*ones(size(t));
%     
%     %make sure d has no NaN entries (e.g., from heaviside functions)
%     nanind = find(isnan(handles.signalinfo.d));
%     if ~isempty(nanind)
%         handles.signalinfo.d(nanind) = handles.signalinfo.d(nanind+1);
%     end
% 
%     %update plate motion panel in GUI
%     set(handles.platemotionfilename,'string',handles.plateinfo.filename);
% 
%     %update control signals in GUI
%     PlotControls(handles)
% 
%     %update plate signals in GUI
%     PlotPlate(handles)
% 
% end

guidata(hObject, handles)

% --- Executes during object creation, after setting all properties.
function Alin_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Alin (see GCBO)
% eventdata  reserved - to be defined in alin future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have alin white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Aang_Callback(hObject, eventdata, handles)
% hObject    handle to Aang (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Aang as text
%        str2double(get(hObject,'String')) returns contents of Aang as a double

Aang_char = get(hObject,'String');

if isempty(Aang_char)
    Aang_char = '1';
    set(hObject,'string',Aang_char)
    set(handles.Aang,'string',mat2str(handles.plateinfo.Aang));
end

if ~strcmp(Aang_char, num2str(handles.plateinfo.Aang))
    handles.plateinfo.Aang = str2num(Aang_char);
end

guidata(hObject, handles)

% --- Executes during object creation, after setting all properties.
function Aang_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Aang (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in viewGn_flexure.
function viewGn_flexure_Callback(hObject, eventdata, handles)
% hObject    handle to viewGn_flexure (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if ~isempty(handles.flexureinfo.Gn_flexure)
    ViewGn_flexure_GUI(handles)
else
    warndlg('No flexure data exists.')
    uiwait
end



function maxforceharmonic_Callback(hObject, eventdata, handles)
% hObject    handle to maxforceharmonic (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of maxforceharmonic as text
%        str2double(get(hObject,'String')) returns contents of maxforceharmonic as a double

handles.forceinfo.maxharmonic = eval(get(hObject,'string'));
PlotForces(handles)
guidata(hObject, handles)

% --- Executes during object creation, after setting all properties.
function maxforceharmonic_CreateFcn(hObject, eventdata, handles)
% hObject    handle to maxforceharmonic (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


