%Initializes plots for speakers.  the control signal (green) and the
%acceleration signal (red) are initially horizontal lines at zero

function InitializeForcePlots(handles)

t_all = handles.plateinfo.t_all;
T = handles.plateinfo.T;
f = handles.signalinfo.f;

titlefontsize = 8;
titletext = {'F_x','F_y','F_z','M_x','M_y','M_z'};

forcesignals = handles.globalinfo.forcesignals;
for i = 1:numel(forcesignals)
    eval(['axes(handles.',forcesignals{i},'_axes)'])
    cla
    title(titletext{i},'fontsize',titlefontsize);
    set(gca, 'xlim', [0 T]);
    line(t_all,f(:,i),'Color','k','tag','f');
    if i == 1
        ylabel('F (N)')
    end
    if i == 4
        ylabel('M (Nm)')
    end
    if i == 3 || i == 6
        xlabel('Time(s)')
    end
end
 
