%This function plots the control (green) and acceleration (red) signals
%corresponding to the speakers.

function PlotForces(handles)

forcesignals = handles.globalinfo.forcesignals;
f = handles.signalinfo.f;

f_fft_plot = fft(f);
f_fft_plot(handles.forceinfo.maxharmonic+1:end-handles.forceinfo.maxharmonic+1,:) = 0;
f = ifft(f_fft_plot);


t_all = handles.plateinfo.t_all;

%find handles for f.  each handles is a vector with
%numel(forcesignals) components (one handle for each of the plots)
f_han = findobj('tag','f');

for i = 1:numel(forcesignals)
    %go to ith axes of control signals panel
    eval(['axes(handles.',forcesignals{i},'_axes)'])
    
    %determine handles to f line objects in axes so f_han(1)
    %corresponds to forcesignals{end}
    set(f_han(numel(forcesignals)+1-i),'xdata',t_all,'ydata',f(:,i)) %update f

    set(gca,'xlim',[0 t_all(end)])
end